
#import os
#import sys
from math import *
from numpy import inf

#name 
name = "L3_Porcar_et_al" 

#title
title = "User model for L3_Porcar_et_al"

#description
description = "Form factor of discoids averaged over random orientations"

#parameters 
parameters = [ 
                ['sld_solv', '', 6.35, [-inf, inf], '', ''],
                ['sld_L3', '', 0.8, [-inf, inf], '', ''],
                ['thickness', '', 300, [-inf, inf], 'volume', ''],
                ['radii', '', 700, [-inf, inf], 'volume', ''],
             ]


def form_volume(*arg): 
    return 1.0 

def ER(*arg): 
    return 1.0 

def Iq(x , sld_solv, sld_L3, thickness, radii):
    if x > 0:
       y = 4*(pi*(radii**2)*((sld_L3 - sld_solv)**2))*((1 - cos(x*thickness)*exp(- (x**2)*(thickness**2)/32))/(x**2))/((x**2)*(radii**2) + 2*exp(- (x**2)*(radii**2)/6))
    else: 
       y = 1
    return y 

def Iqxy(x, y , sld_solv, sld_L3, thickness, radii):
    return Iq(sqrt(x**2+y**2) , sld_solv, sld_L3, thickness, radii)
