r"""
Definition
----------

Calculates L3_Porcar_et_alNEW.

Form factor of discoids averaged over random orientations

References
----------

Authorship and Verification
---------------------------

* **Author:** --- **Date:** 2018YYY-08m-07d
* **Last Modified by:** --- **Date:** 2018YYY-08m-07d
* **Last Reviewed by:** --- **Date:** 2018YYY-08m-07d
"""

from math import *
from numpy import inf

name = "L3_Porcar_et_alNEW"
title = "User model for L3_Porcar_et_alNEW"
description = """Form factor of discoids averaged over random orientations"""

parameters = [ 
#   ["name", "units", default, [lower, upper], "type", "description"],
    ['sld_solv', '', 6.35, [-inf, inf], '', ''],
    ['sld_L3', '', 0.8, [-inf, inf], '', ''],
    ['thickness', '', 300, [-inf, inf], '', ''],
    ['radii', '', 700, [-inf, inf], '', ''],
    ]

def Iq(x, sld_solv, sld_L3, thickness, radii):
    """Absolute scattering"""
    if x > 0:

        y = 4*(pi*(radii**2)*((sld_L3 - sld_solv)**2))*((1 - cos(x*thickness)*exp(- (x**2)*(thickness**2)/32))/(x**2))/((x**2)*(radii**2) + 2*exp(- (x**2)*(radii**2)/6))

    else:

        y= 1

    return y
## uncomment the following if Iq works for vector x
#Iq.vectorized = True

#def Iqxy(x, y, sld_solv, sld_L3, thickness, radii):
#    """Absolute scattering of oriented particles."""
#    ...
#    return oriented_form(x, y, args)
## uncomment the following if Iqxy works for vector x, y
#Iqxy.vectorized = True
